# Contributing to AutoGGUF

First off, thanks for taking the time to contribute! 🎉👍

## How Can I Contribute?

### Reporting Bugs

- Use the issue tracker to report bugs
- Describe the bug in detail
- Include screenshots if possible

### Suggesting Enhancements

- Use the issue tracker to suggest enhancements
- Explain why this enhancement would be useful

### Your First Code Contribution

1. Fork the repo
2. Create your feature branch (`git checkout -b feature/AmazingFeature`)
3. Commit your changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request

## Styleguides

### Git Commit Messages

- Use the present tense ("Add feature" not "Added feature")
- Use the imperative mood ("Move cursor to..." not "Moves cursor to...")
- Limit the first line to 72 characters or less

### Python Styleguide

- Follow PEP 8
- Use meaningful variable names
- Comment your code, but don't overdo it

## Questions?

Feel free to contact the project maintainers if you have any questions.
